package com.yingxin.springcloudconsumer.service;

import com.netflix.hystrix.contrib.javanica.annotation.HystrixCommand;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

@Service
public class TestService {

    private final RestTemplate restTemplate;

    public TestService(RestTemplate restTemplate) {
        this.restTemplate = restTemplate;
    }

    @HystrixCommand(fallbackMethod = "helloFallBack", threadPoolKey = "HelloFastService")
    public String hello() {
        System.out.println("执行任务线程：" + Thread.currentThread().getName());
        return restTemplate.getForObject("http://spring-cloud-server-HelloWorldFast/hello",String.class);
    }

    @HystrixCommand(fallbackMethod = "helloFallBack", threadPoolKey = "HelloSlowService")
    public String hello2() {
        System.out.println("执行任务线程：" + Thread.currentThread().getName());
        return restTemplate.getForObject("http://spring-cloud-server-HelloWorldSlow/hello",String.class);
    }

    public String helloFallBack() {
        System.out.println("error：" + Thread.currentThread().getName());
        return "error";
    }
}
